/*

Copyright (C) 2002-2003, Jeffrey D. Argast.

The authors make NO WARRANTY or representation, either express or implied,
with respect to this software, its quality, accuracy, merchantability, or
fitness for a particular purpose.  This software is provided "AS IS", and you,
its user, assume the entire risk as to its quality and accuracy.

Permission is hereby granted to use, copy, modify, and distribute this
software or portions thereof for any purpose, without fee, subject to these
conditions:

(1) If any part of the source code is distributed, then this
statement must be included, with this copyright and no-warranty notice
unaltered.

(2) Permission for use of this software is granted only if the user accepts
full responsibility for any undesirable consequences; the authors accept
NO LIABILITY for damages of any kind.

*/

#import "PerforceActionOpened.h"
#import "PerforceOutputParsers.h"

@implementation PerforceActionOpened

+ (void) defaultRunFor:(id)owner selector:(SEL)aSelector clientOnly:(BOOL) clientOnly
{
	PerforceActionOpened* action = [[[PerforceActionOpened alloc] init] autorelease];
	
	[action runFor:owner selector:aSelector clientOnly:clientOnly];
}

- (void) dealloc
{
	[fOwner release];
	[fOpenedArray release];
	
	[super dealloc];
}

- (void) processOutput: (NSString*) perforceOutput
{
	fOpenedArray = [[PerforceOutputParsers parseOpenedOutput:perforceOutput clientOnly:fClientOnly] retain];
}

- (void) runFor:(id)owner selector:(SEL)aSelector clientOnly:(BOOL) clientOnly
{
    NSMutableArray* commandAndArgs = [[[NSMutableArray alloc] init] autorelease];
	
	fOwner      = [owner retain];
	fSelector   = aSelector;
	fClientOnly	= clientOnly;
	
	[commandAndArgs addObject:@"opened"];
	
    if ( !fClientOnly )
    {
		[commandAndArgs addObject:@"-a"];
    }
    
    [self runAction:commandAndArgs stdInString:nil readToEOF:YES];
}

- (NSArray*) getOpened
{
	return fOpenedArray;
}

@end
